local ItemCache =  FlexBar2:NewModule("ItemCache", "AceEvent-2.0");
ItemCache.Version = 1;

local Cache = {};
ItemCache.Cache = Cache;

function ItemCache:Activate()
    self:BuildItemCache();
    self:RegisterEvent("BAG_UPDATE", "BuildItemCache");
    self:RegisterEvent("UNIT_INVENTORY_CHANGED", function(UnitId) if(UnitId == "player") then ItemCache:BuildItemCache(); end end);
end

function ItemCache:BuildItemCache()
    FlexBar2:Debug("Building cache");
    for ItemLink, _ in pairs(Cache) do
        for Info, _ in pairs(Cache[ItemLink]) do
            Cache[ItemLink][Info] = nil;
        end
    end
    for Bag = 0, 4 do
        for Slot =1, GetContainerNumSlots(Bag) do
            local ItemLink = GetContainerItemLink(Bag, Slot);
            if(ItemLink) then
                ItemLink = "itemlink:" .. ItemLink
                if(type(Cache[ItemLink]) ~= "table") then Cache[ItemLink] = {}; end
                Cache[ItemLink].Bag = Bag;
                Cache[ItemLink].BagSlot = Slot;
            end
        end
    end
    for Slot = 0, 23 do
        local ItemLink = GetInventoryItemLink("player", Slot);
        if(ItemLink) then
            ItemLink = "itemlink:" .. ItemLink;
            if(type(Cache[ItemLink]) ~= "table") then Cache[ItemLink] = {}; end
            Cache[ItemLink].InvSlot = Slot;
        end
    end
end

function ItemCache:GetItemInfo(ItemLink)
    return Cache[ItemLink] or Cache["itemlink:" .. ItemLink] or false;
end
